App.Events.SEfctv = class SEfctv extends App.Events.BaseEvent {
	constructor(actors, params) {
		super(actors, params);
	}

	eventPrerequisites() {
		return [
			() => V.FCTV.receiver > 0,
			() => V.FCTV.pcViewership.frequency !== -1,
			() => V.FCTV.pcViewership.count === 0
		];
	}

	execute(node) {
		V.nextButton = "Continue";
		V.nextLink = "Scheduled Event";
		V.encyclopedia = "FCTV";
		if (V.week > 50 && V.FCTV.remote < 2) {
			node.append(App.UI.DOM.renderPassage("SE FCTV Remote")); // TODO: get that shit out of twine
		} else {
			const watchDiv = App.UI.DOM.appendNewElement("div", node, FctvDisplay());
			watchDiv.id = "fctv-watch";
		}
	}
};
