App.Facilities.HGSelect = function() {
	let div = document.createElement("div");
	const f = document.createDocumentFragment();
	let r = [];
	let links = [];

	App.UI.DOM.appendNewElement("h1", f, "Head Girl Management");

	if (S.HeadGirl) {
		const HGName = SlaveFullName(S.HeadGirl);
		const {
			His, He, he,
			his, him, himself
		} = getPronouns(S.HeadGirl);
		
		f.append(`${SlaveFullName(S.HeadGirl)} is working as your HeadGirl`);
		if (V.arcologies[0].FSEgyptianRevivalistLaw === 1) {
			f.append(`/Consort; serving and providing comfort, in addition to performing normal Head Girl duties`);
		}
		f.append(`. `);
		if (V.HGSuite) {
			f.append(`Currently living in ${capFirstChar(V.HGSuiteName)} `);
		}
		f.append(App.UI.DOM.link("Remove HeadGirl", () => {
			removeJob(S.HeadGirl, Job.HEADGIRL);
		},
		[], "Main"
		));
		
		App.UI.DOM.appendNewElement("div", f, `Slave training	${HGName} will prioritize enabled items in the following order`, "bold");

		div.append(App.UI.DOM.makeCheckbox("headGirlTrainsHealth"), " Health");
		App.UI.DOM.appendNewElement("div", f, div, "indent");
		
		div = document.createElement("div");
		div.append(App.UI.DOM.makeCheckbox("headGirlTrainsParaphilias"), " Paraphilias");
		App.UI.DOM.appendNewElement("div", f, div, "indent");
		
		if (V.headGirlTrainsFlaws) {
			r.push(`${HGName} will train flaws.`,);
		} else if (V.headGirlSoftensFlaws) {
			r.push(`${HGName} will softern flaws into quirks.`);
		} else if (V.headGirlOverridesQuirks) {
			r.push(`${HGName} will override quirks.`);
		}

		links.push(App.UI.DOM.link(" Override quirks", () => {
			V.headGirlTrainsFlaws = 0;
			V.headGirlSoftensFlaws = 0;
			V.headGirlOverridesQuirks = 1;
		},
		[], passage()
		));
		links.push(App.UI.DOM.link(" Soften flaws", () => {
			V.headGirlTrainsFlaws = 0;
			V.headGirlSoftensFlaws = 1;
			V.headGirlOverridesQuirks = 0;
		},
		[], passage()
		));
		links.push(App.UI.DOM.link(" Train flaws", () => {
			V.headGirlTrainsFlaws = 1;
			V.headGirlSoftensFlaws = 0;
			V.headGirlOverridesQuirks = 0;
		},
		[], passage()
		));
		
		r.push(App.UI.DOM.generateLinksStrip(links));
		App.Events.addNode(f, r, "div", "indent");

		div = document.createElement("div");
		div.append(App.UI.DOM.makeCheckbox("headGirlTrainsObedience"), " Obedience");
		App.UI.DOM.appendNewElement("div", f, div, "indent");

		div = document.createElement("div");
		div.append(App.UI.DOM.makeCheckbox("headGirlTrainsSkills"), " Skills");
		App.UI.DOM.appendNewElement("div", f, div, "indent");

		App.UI.DOM.appendNewElement("div", f, "Training methods: ", "underline");
		
		r = [];
		if (V.HGSeverity === 1) {
			r.push(`${HGName} will be <span class="bold">aggressive</span> when punishing, with rape strongly encouraged.`);
			r.push(App.UI.DOM.link(" Moderate", () => {
				V.HGSeverity = 0;
			},
			[], passage()
			));
		} else if (V.HGSeverity === 0) {
			links = [];
			r.push(`${HGName} will be <span class="bold">moderate</span> when punishing, carefully selecting appropriate consequences.`);
			links.push(App.UI.DOM.link(" Be aggressive", () => {
				V.HGSeverity = 1;
			},
			[], passage()
			));
			links.push(App.UI.DOM.link(` Apply restrictions`, () => {
				V.HGSeverity = -1;
			},
			[], passage()
			));
			r.push(App.UI.DOM.generateLinksStrip(links));
		} else if (V.HGSeverity === -1) {
			r.push(`${HGName} will be <span class="bold">respectful</span> when punishing, treating slaves decently.`);
			r.push(App.UI.DOM.link(" Be stricter", () => {
				V.HGSeverity = 0;
			},
			[], passage()
			));
		}
		App.Events.addNode(f, r, "div", "indent");

		r = [];
		if (V.HGPiercings === 1) {
			r.push(`${HGName} is <span class="bold">allowed</span> to use piercings as a tool to improve slaves' attitudes.`);
			r.push(App.UI.DOM.link(" Disallow", () => {
				V.HGPiercings = 0;
			},
			[], passage()
			));
		} else {
			r.push(`${HGName} is <span class="bold">not allowed</span> to use piercings as a tool to improve slaves' attitudes.`);
			r.push(App.UI.DOM.link(" Allow", () => {
				V.HGPiercings = 1;
			},
			[], passage()
			));
		}
		App.Events.addNode(f, r, "div", "indent");

		r = [];
		App.UI.DOM.appendNewElement("div", f, "Behavior towards you: ", "underline");
		if (V.HGFormality === 1) {
			r.push(`${HGName} will be <span class="bold">formal:</span> you will always be called ${getWrittenTitle(S.HeadGirl)}, just like any other slave.`);
			r.push(App.UI.DOM.link(" Allow private informality", () => {
				V.HGFormality = 0;
			},
			[], passage()
			));
		} else {
			r.push(`${HGName} is allowed to be <span class="bold">informal:</span> in private, you can be called ${properTitle()}.`);
			r.push(App.UI.DOM.link(" Maintain complete formality", () => {
				V.HGFormality = 1;
			},
			[], passage()
			));
		}
		App.Events.addNode(f, r, "div", "indent");
		
		if (V.seePreg !== 0) {
			if (V.universalRulesImpregnation === "HG") {
				f.append(`${HGName} is responsible for impregnating fertile slaves.`);
				V.HGCum = resetHGCum(S.HeadGirl);
				if (canPenetrate(S.HeadGirl) && S.HeadGirl.pubertyXY === 1) {
					f.append(`To maximize the chances of impregnation, ${he} will fuck fertile pussies frequently during the week. ${S.HeadGirl.slaveName} can service ${V.HGCum} slaves this way.`);
					if (S.HeadGirl.devotion > 95) {
						f.append(`${He} loves you so much ${he}'ll fuck them until ${he}'s sore.`);
					} else {
						f.append(`If ${he} were more devoted to you, ${he} might be able to drive ${himself} to get hard and service one more.`);
					}
					if (S.HeadGirl.balls >= 120) {
						r.push(`${His} unreal balls produce nearly an endless supply of semen; ${his} ability to impregnate is almost limitless.`);
					} else if (S.HeadGirl.balls >= 80) {
						r.push(`${His} inhuman balls produce so much semen ${he} can easily impregnate twenty girls in one sitting.`);
					} else if (S.HeadGirl.balls >= 50) {
						r.push(`${His} giant balls produce so much semen ${he} can easily impregnate twelve girls in one sitting.`);
					} else if (S.HeadGirl.balls >= 25) {
						r.push(`${His} oversized balls produce so much semen ${he} can cum repeatedly in a single session.`);
					} else if (S.HeadGirl.balls >= 5) {
						r.push(`${His} big balls produce so much semen ${he} can cum more before ${he}'s drained.`);
					} else {
						r.push(`Bigger balls would let ${him} cum more before ${he}'s drained.`);
					}
					if (S.HeadGirl.health.condition > 95) {
						f.append(`${His} wonderful health lets ${him} get hard and stay hard all the time.`);
					} else {
						f.append(`If ${his} health were perfect, ${he} might be able to get hard more often.`);
					}
					if (S.HeadGirl.energy > 95) {
						f.append(`${His} nymphomania drives ${him} to go above and beyond in this.`);
					} else {
						f.append(`A more powerful sex drive could reduce ${his} refractory period.`);
					}
				} else {
					f.append(`However, ${S.HeadGirl.slaveName} cannot perform this duty.`);
				}
				r.push(App.UI.DOM.link(` Rescind ${his} impregnation responsibility`, () => {
					V.universalRulesImpregnation = "none";
				},
				[], passage()
				));
				r.push(App.UI.DOM.link(` See to it yourself`, () => {
					V.universalRulesImpregnation = "PC";
				},
				[], passage()
				));
				f.append(App.UI.DOM.generateLinksStrip(r));
			} else {
				if (canPenetrate(S.HeadGirl) && S.HeadGirl.pubertyXY === 1) {
					App.UI.DOM.appendNewElement("div", f, `${HGName} is capable of impregnating slaves, but it's not part of ${his} responsibilities.`).append(
						App.UI.DOM.link(` Assign ${him} to impregnate`, () => {
							V.universalRulesImpregnation = "HG";
						},
						[], passage()
						));
				}
			}
		}
	} else {
		f.append(`No HeadGirl assigned, appoint one from your devoted slaves.`);
	}

	f.append(App.UI.SlaveList.facilityManagerSelection(App.Entity.facilities.headGirlSuite, "HG Select"));
	return f;
};
