App.Facilities.RecruiterSelect = function() {
	const f = document.createDocumentFragment();
	const recruiterCap = document.createDocumentFragment();
	let newLine = document.createElement("div");
	let r = [];
	
	App.UI.DOM.appendNewElement("h1", f, "Recruiter Management");

	if (S.Recruiter) {
		f.append(`${SlaveFullName(S.Recruiter)} is working as your Recruiter, currently ${V.recruiterTarget !== "other arcologies" ? 'recruiting girls. ' : 'acting as a sexual Ambassador'}`);
		if (V.recruiterTarget === "other arcologies") {
			if (V.arcologies[0].influenceTarget === -1) {
				f.append(`.<span class='red'>Since you have not selected another arcology to influence, your recruiter's talents are going to waste. Select an influence target to apply them. `);
			} else {
				f.append(` to `);
				for (const arc of V.arcologies) {
					if (arc.direction === V.arcologies[0].influenceTarget) {
						f.append(`${arc.name}` );
						break;
					}
				}
			}
		}
		f.append(App.UI.DOM.link("Remove Recruiter", () => {
			removeJob(S.Recruiter, Job.RECRUITER);
		},
		[], "Main"
		));
		
		App.UI.DOM.appendNewElement("div", f);
		f.append(`Your recruiter will target ${V.recruiterTarget}, `);
		if (V.recruiterTarget === "desperate whores") {
			f.append("they will be skilled but unhealthy. ");
		} else if (V.recruiterTarget === "young migrants") {
			f.append("they will be young and inexperienced but unhealthy. ");
		} else if (V.recruiterTarget === "Will be mature") {
			f.append("they will be mature. ");
		} else if (V.recruiterTarget === "expectant mothers") {
			f.append("they will be pregnant and likely unhealthy. ");
		} else if (V.recruiterTarget === "dissolute sissies") {
			f.append("they will be born male and have some experience. ");
		} else if (V.recruiterTarget === "reassignment candidates") {
			f.append("they will be born male. ");
		} else if (V.recruiterTarget === "other arcologies") {
			f.append("they will appoint the Recruiter to be a sexual Ambassador. ");
		}

		r.push(App.UI.DOM.link(`Desperate whores`, () => {
			V.recruiterTarget = "desperate whores";
		},
		[], passage()
		));

		r.push(App.UI.DOM.link("Young migrants", () => {
			V.recruiterTarget = "young migrants";
		},
		[], passage()
		));

		r.push(App.UI.DOM.link("Recent divorcees", () => {
			V.recruiterTarget = "recent divorcees";
		},
		[], passage()
		));

		if (V.seeDicks !== 100 && V.seePreg !== 0) {
			r.push(App.UI.DOM.link("Expectant mothers", () => {
				V.recruiterTarget = "expectant mothers";
			},
			[], passage()
			));
		}

		if (V.seeDicks !== 0) {
			r.push(App.UI.DOM.link("Dissolute sissies", () => {
				V.recruiterTarget = "dissolute sissies";
			},
			[], passage()
			));

			r.push(App.UI.DOM.link("Reassignment candidates", () => {
				V.recruiterTarget = "reassignment candidates";
			},
			[], passage()
			));
		}

		if (V.arcologies.length > 1) {
			r.push(App.UI.DOM.link("Other arcologies' cultures", () => {
				V.oldRecruiterTarget = V.recruiterTarget;
				V.recruiterTarget = "other arcologies";
			},
			[], passage()
			));
		}

		f.append(App.UI.DOM.generateLinksStrip(r));

		newLine.append(App.UI.DOM.makeCheckbox("recruiterEugenics"), App.UI.DOM.makeElement("note", " Target only individuals that can pass eugenics SMRs. This option will increase time it takes to recruit depending on how many eugenics SMR are active."));
		f.append(newLine);

		let idleTarget = 2 +
		(V.brothel + V.club + V.arcade + V.dairy + V.servantsQuarters) +
		V.masterSuite + V.HGSuite + V.dojo + V.brothel + V.club;
		if (V.dairy && V.dairyRestraintsSetting < 2) {
			idleTarget++;
		}
		idleTarget += V.farmyard + V.servantsQuarters + V.masterSuite + V.schoolroom + V.spa;
		idleTarget += V.nursery + V.clinic + V.cellblock;

		newLine = document.createElement("div");
		newLine.append("Suspend active recruiting and focus on publicity when: ");
		if (V.recruiterIdleRule === "number") {
			newLine.append(`${V.recruiterIdleNumber} sex slaves owned`);
		} else if (V.recruiterIdleRule === "facility") {
			newLine.append(`match facility expansion, `);
			if (idleTarget >= 20) {
				newLine.append(`${idleTarget} positions.`);
			} else {
				newLine.append("20 positions (rule minimum).");
			}
		} else {
			newLine.append("always recruit");
		}
		f.append(newLine);

		r = [];
		r.push(App.UI.DOM.link("Always recruit", () => {
			V.recruiterIdleRule = "always";
		},
		[], passage()
		));
		r.push(App.UI.DOM.link("Facilities & leadership", () => {
			V.recruiterIdleRule = "facility";
		},
		[], passage()
		));

		recruiterCap.append(App.UI.DOM.link("Set to this many slaves ", () => {
			V.recruiterIdleRule = "number";
		},
		[], passage()
		));
		if (V.recruiterIdleRule === "number") {
			recruiterCap.append(App.UI.DOM.makeTextBox(V.recruiterIdleNumber, (v) => {
				V.recruiterIdleNumber = v;
				Engine.play(passage());
			}, true));
		}
		r.push(recruiterCap);

		f.append(App.UI.DOM.generateLinksStrip(r));
		App.UI.DOM.appendNewElement("div", f, "'Facilities' doesn't include training slots in cellblock, schoolroom, spa, clinic (but does include those leaders)");

		V.recruiterIdleNumber = Math.max(Math.trunc(Number(V.recruiterIdleNumber) || 20), 20);
	} else {
		f.append(`No Recruiter assigned, appoint one from your devoted slaves.`);
	}

	f.append(App.UI.SlaveList.facilityManagerSelection(App.Entity.facilities.penthouse, "Recruiter Select"));
	return f;
};
