/**
 * @param {App.Entity.SlaveState} slave
 * @param {function():void} refresh
 * @returns {DocumentFragment}
 */
App.UI.SlaveInteract.financial = function(slave, refresh) {
	const el = new DocumentFragment();
	let r;
	let linkArray;
	const {
		He, His,
		his, him
	} = getPronouns(slave);
	if (V.studio === 1) {
		App.UI.DOM.appendNewElement("h3", el, "Media");
		slave.porn.spending = Math.clamp(Math.ceil(slave.porn.spending / 1000) * 1000, 0, 5000);

		if (slave.porn.prestige === 3) {
			App.UI.DOM.appendNewElement("div", el, `${He} is so prestigious in the realm of ${slave.porn.fameType} porn that ${his} fame is self-sustaining.`, "note");
		} else if (slave.porn.feed === 0) {
			r = [];
			r.push(`The media hub is not releasing highlights of ${his} sex life.`);
			r.push(
				App.UI.DOM.link(
					"Release",
					() => {
						slave.porn.feed = 1;
						refresh();
					}
				)
			);
			App.Events.addNode(el, r, "div");
		} else {
			r = [];
			r.push(`The media hub is releasing highlights of ${his} sex life`);
			if (slave.porn.spending < 500) {
				r.push(`to those who can find it.`);
			} else if (slave.porn.spending < 2500) {
				r.push(`on several websites.`);
			} else if (slave.porn.spending > 5000) {
				r.push(`through your old distributor.`);
			} else {
				r.push(`on many websites.`);
			}
			if (slave.porn.spending === 0) {
				linkArray = [];
				linkArray.push(
					App.UI.DOM.link(
						"Halt",
						() => {
							slave.porn.feed = 0;
							slave.porn.focus = "none";
							refresh();
						}
					)
				);
				linkArray.push(
					App.UI.DOM.link(
						"Publicize",
						() => {
							slave.porn.spending += 1000;
							refresh();
						},
						[],
						"",
						`Will cost ${cashFormat(1000)} weekly.`
					)
				);
				r.push(App.UI.DOM.generateLinksStrip(linkArray));
				App.Events.addNode(el, r, "div");
			} else {
				r.push(
					App.UI.DOM.makeTextBox(
						slave.porn.spending,
						v => {
							slave.porn.spending = v;
						},
						true
					)
				);
				r.push(`weekly is spent to publicize them.`);

				linkArray = [];
				linkArray.push(
					App.UI.DOM.link(
						"Halt",
						() => {
							slave.porn.spending = 0;
							slave.porn.feed = 0;
							slave.porn.focus = "none";
							V.PCSlutContacts = 1;
							refresh();
						}
					)
				);
				if (slave.porn.spending <= 4000) {
					linkArray.push(
						App.UI.DOM.link(
							"Increase",
							() => {
								slave.porn.spending += 1000;
								refresh();
							},
							[],
							"",
							`Spending more than ${cashFormat(5000)} weekly will have no effect.`
						)
					);
				}
				linkArray.push(
					App.UI.DOM.link(
						"Decrease",
						() => {
							slave.porn.spending -= 1000;
							refresh();
						},
						[],
						"",
						`Will cost ${cashFormat(1000)} weekly.`
					)
				);
				r.push(App.UI.DOM.generateLinksStrip(linkArray));
				App.Events.addNode(el, r, "div");

				if (V.PC.career === "escort" || V.PC.career === "prostitute" || V.PC.career === "child prostitute") {
					r = [];
					if (V.PC.career === "escort") {
						r.push(`You retain some contacts from your past life in the industry that may be willing to cut you some discounts should you return to it.`);
					} else {
						r.push(`You were approached in the past to star in some adult films and they may be willing to cut you some discounts should you accept their offer.`);
					}
					if (V.PCSlutContacts !== 2) {
						r.push(`You are not baring your body for all to see.`);
						r.push(
							App.UI.DOM.link(
								`Star in porn for a discount`,
								() => {
									V.PCSlutContacts = 2;
									refresh();
								}
							)
						);
					} else {
						if (V.PC.career === "escort") {
							r.push(`You are starring in hardcore porn once more.`);
						} else if (V.PC.actualAge < V.minimumSlaveAge) {
							r.push(`You are taking part in porn that may disturb people.`);
						} else {
							r.push(`You are starring in some hardcore porn.`);
						}
						r.push(
							App.UI.DOM.link(
								`Stop doing porn for a discount`,
								() => {
									V.PCSlutContacts = 1;
									refresh();
								}
							)
						);
					}
					App.Events.addNode(el, r, "div");
				}
			}
			if (V.studioFeed === 1) {
				r = [];
				if (slave.porn.viewerCount < 100) {
					r.push(`${He} lacks the fame in porn needed to discern what ${his} feed is getting tagged as.`);
				} else {
					if (slave.porn.prestige > 0) {
						r.push(`${He} is known for ${slave.porn.fameType}${(slave.porn.prestige > 1) ? ` and viewers have grown to expect it from ${him}` : ``}.`);
					}
					if (slave.porn.focus === "none") {
						r.push(`You are allowing ${his} viewers to guide the direction of ${his} content.`);
					} else {
						r.push(`You are focusing attention on the ${slave.porn.focus} aspect of ${his} content.`);
					}
					r.push(App.Porn.genreChoiceLinks("Slave Interact", slave));
				}
				App.Events.addNode(el, r, "div");
			}
		}
	}
	App.UI.DOM.appendNewElement("h3", el, "Financial");
	App.UI.DOM.appendNewElement("p", el, slaveExpenses(slave));

	r = [];
	linkArray = [];
	if (V.slaveCostFactor > 1) {
		r.push(App.UI.DOM.makeElement("span", `The slave market is bullish; the price of slaves is high.`, "yellow"));
	} else if ((V.slaveCostFactor < 1)) {
		r.push(App.UI.DOM.makeElement("span", `The slave market is bearish; the price of slaves is low.`, "yellow"));
	}

	if (V.slaves.length < 2) {
		r.push("You cannot sell your last slave");
	} else if (slave.origin === "You bought ${him} from a body dump, completely broken." && (V.week - slave.weekAcquired <= 8)) {
		r.push(`A discarded slave must be kept for at least two months to ensure health before being sold.`);
	} else if (slave.accent > 3) {
		r.push(`${His} lack of language and basic life skills is a red sign to most slave appraisers. ${He} must not act like a child to be sold without raising suspicion.`);
	} else {
		linkArray.push(
			App.UI.DOM.link(
				`Sell ${him}`,
				() => {
					cashX(-500, "personalBusiness", slave);
				},
				[],
				"Sell Slave",
				`Listing ${him} for sale will cost ${cashFormat(500)}`
			)
		);
		if ((V.seeAge !== 0) && (slave.indenture < 1)) {
			linkArray.push(
				App.UI.DOM.passageLink(
					`Retire ${him}`,
					"retire",
				)
			);
		}
		linkArray.push(
			App.UI.DOM.passageLink(
				`Discard ${him}`,
				"Discard Confirm",
			)
		);
		if (V.seeExtreme === 1 && V.arcologies[0].FSPaternalist === "unset" && V.cheatMode === 1) {
			linkArray.push(
				App.UI.DOM.passageLink(
					`Threaten ${his} life`,
					"KillSlave",
				)
			);
		}
	}
	linkArray.push(
		App.UI.DOM.passageLink(
			`Export this slave`,
			"Export Slave",
		)
	);
	if (V.cheatMode) {
		linkArray.push(
			App.UI.DOM.passageLink(
				`Import a slave`,
				"Import Slave",
			)
		);
	}
	r.push(App.UI.DOM.generateLinksStrip(linkArray));
	App.Events.addNode(el, r, "p");
	return el;
};
