App.Markets["Household Liquidator"] = function() {
	V.market.introType = "liquidator";
	V.market.newSlavesDone = 0;

	const el = new DocumentFragment();
	let slave;
	let r = [];
	const _newSlaves = [];
	let _totalCost;
	if (jsRandom(1, 100) > 50) {
		// Old enough to have a younger sibling who can be a slave.
		slave = GenerateNewSlave(null, {
			minAge: (V.minimumSlaveAge + 2), disableDisability: 1
		});
		finishSlave();
		setMissingParents(slave);

		// Create opposite sex chance of relative
		const _oppositeSex = (slave.genes !== GenerateChromosome());
		App.UI.DOM.appendNewElement("p", el, `The household liquidator is offering a set of siblings for sale. You are permitted to inspect both slaves.`);

		const _relativeSlave = generateRelatedSlave(slave, "younger sibling", _oppositeSex);
		_newSlaves.push(slave);
		_newSlaves.push(_relativeSlave);

		let _slaveCost = slaveCost(slave, false, true);
		if (V.slavesSeen > V.slaveMarketLimit) {
			_slaveCost += Math.trunc(_slaveCost * ((V.slavesSeen - V.slaveMarketLimit) * 0.1));
		}
		_totalCost = _slaveCost * 3;
	} else if (jsRandom(1, 100) > 20) {
		// Old enough to have a child who can be a slave.
		slave = GenerateNewSlave(null, {
			minAge: (V.fertilityAge + V.minimumSlaveAge), maxAge: 42, ageOverridesPedoMode: 1, disableDisability: 1
		});
		if (slave.vagina > -1) {
			slave.boobs += 100;
		}
		slave.butt += 1;
		if (slave.vagina > -1) {
			slave.vagina += 1;
		}
		if (slave.vagina > -1) {
			slave.counter.birthsTotal = 1;
		}
		finishSlave();
		// Create opposite sex chance of relative
		const _oppositeSex = (slave.genes !== GenerateChromosome());
		const {his, mother} = getPronouns(slave);

		const _relativeSlave = generateRelatedSlave(slave, "child", _oppositeSex);
		const {daughter} = getPronouns(_relativeSlave);

		r.push(`The household liquidator is offering a ${mother} and ${his} ${daughter} for sale. You are permitted to inspect both slaves.`);
		App.UI.DOM.appendNewElement("p", el, r.join(" "));

		_newSlaves.push(slave);
		_newSlaves.push(_relativeSlave);

		let _slaveCost = slaveCost(slave, false, true);
		if (V.slavesSeen > V.slaveMarketLimit) {
			_slaveCost += Math.trunc(_slaveCost * ((V.slavesSeen - V.slaveMarketLimit) * 0.1));
		}
		_totalCost = _slaveCost * 3;
	} else {
		slave = GenerateNewSlave(null, {disableDisability: 1});
		finishSlave();
		setMissingParents(slave);
		App.UI.DOM.appendNewElement("p", el, `The household liquidator is offering something special: identical twins. The markup is huge, but the merchandise isn't something you see every day.`);

		const _relativeSlave = generateRelatedSlave(slave, "twin");
		_newSlaves.push(slave);
		_newSlaves.push(_relativeSlave);

		let _slaveCost = slaveCost(slave, false, true);
		if (V.slavesSeen > V.slaveMarketLimit) {
			_slaveCost += Math.trunc(_slaveCost * ((V.slavesSeen - V.slaveMarketLimit) * 0.1));
		}
		_totalCost = _slaveCost * 4;
	}

	el.append(`The price is `);
	el.append(App.UI.DOM.cashFormat(_totalCost));
	el.append(`.`);
	if (V.slavesSeen > V.slaveMarketLimit) {
		el.append(` You have cast such a wide net for slaves this week that it is becoming more expensive to find more for sale. Your reputation helps determine your reach within the slave market.`);
	}

	if (V.cash >= _totalCost) {
		App.UI.DOM.appendNewElement(
			"div",
			el,
			App.UI.DOM.link(
				`Buy their slave contract`,
				() => {
					V.market.newSlaves = _newSlaves;
					V.market.newSlaves.forEach((s) => cashX(forceNeg(_totalCost / V.market.newSlaves.length), "slaveTransfer", s));
				},
				[],
				"Bulk Slave Intro"
			)
		);
	} else {
		el.append(`You lack the necessary funds to buy these slaves.`);
	}
	App.UI.DOM.appendNewElement(
		"div",
		el,
		App.UI.DOM.link(
			`Decline to purchase them and check out another set of slaves`,
			() => {
				V.slavesSeen += 2;
			},
			[],
			"Market"
		)
	);
	App.UI.DOM.appendNewElement("p", el, App.UI.MultipleInspect(_newSlaves, true, "Household Liquidators"));

	return el;

	function finishSlave() {
		slave = Object.assign(slave, {
			origin: "You bought $him from the household liquidator.",
			devotion: jsRandom(-75, -25),
			trust: jsRandom(-45, -25),
			oldDevotion: slave.devotion,
			oldTrust: slave.trust,
			canRecruit: 0
		});
		setHealth(slave, jsRandom(-50, 20));
	}
};
