/**
 *
 * @param {App.Entity.SlaveState} slave
 * @returns {HTMLElement}
 */
App.Interact.fAnimalImpreg = function(slave) {
	const node = document.createElement("div");
	let r = [];
	let eligibility;
	const {him} = getPronouns(slave);

	App.UI.DOM.appendNewElement("h2", node, `Select an eligible animal to knock ${him} up`);

	/* FIXME: this might not work */
	for (const canine of V.canine) {
		if (canBreed(getSlave(V.AS), canine)) {
			App.UI.DOM.appendNewElement("div", node, App.UI.DOM.link(
				`Have a ${canine.species !== "dog" ? canine.species : canine.breed} knock ${him} up`,
				() => jQuery(node).empty().append(content(canine))
			));
			eligibility = true;
		}
	}
	for (const hooved of V.hooved) {
		if (canBreed(getSlave(V.AS), hooved)) {
			App.UI.DOM.appendNewElement("div", node, App.UI.DOM.link(
				`Have a ${hooved.species} knock ${him} up`,
				() => jQuery(node).empty().append(content(hooved))
			));
			eligibility = true;
		}
	}
	for (const feline of V.feline) {
		if (canBreed(getSlave(V.AS), feline)) {
			App.UI.DOM.appendNewElement("div", node, App.UI.DOM.link(
				`Have a ${feline.species !== "dog" ? feline.species : feline.breed} knock ${him} up`,
				() => jQuery(node).empty().append(content(feline))
			));
			eligibility = true;
		}
	}
	if (!eligibility) {
		App.UI.DOM.appendNewElement("div", node, `You have no animals capable of inseminating ${him}`, `note`);
	}
	App.Events.addParagraph(node, r);
	return node;

	function content(animal) {
		const el = new DocumentFragment();
		r.push(`You have a servant lead the`);
		if (animal.species !== "dog" || animal.species !== "cat") {
			r.push(animal.species);
		} else {
			r.push(animal.breed);
		}
		r.push(`in on a leash and feed him a special treat, one laced with high amounts of aphrodisiacs and vasodilators. They have an effect very rapidly, and the`);
		if (animal.species !== "dog" && animal.species !== "cat") {
			r.push(`${animal.species}'s`);
		} else {
			r.push(`${animal.breed}'s`);
		}
		r.push(`${animal.dickSize} cock quickly stands at attention.`);

		return el;
	}
};
