globalThis.eliteBreedingExam = function(slave = null) {
	const frag = new DocumentFragment();
	const eliteAngered = V.failedElite > 100;
	const SlaveProfessionalismEstablished = V.arcologies[0].FSSlaveProfessionalism > 20;
	const preferYounger = V.arcologies[0].FSYouthPreferentialist > 20;
	const partyAnimal = V.arcologies[0].FSHedonisticDecadence > 20;
	const cost = 5000;
	let r = [];
	let test;
	let passing = 0;
	let fixable;

	const result = function() {
		if (slave) {
			if (test === true) {
				return App.UI.DOM.makeElement("span", "PASSED", "lime");
			} else if (fixable) {
				return App.UI.DOM.makeElement("span", "Within fixable range.", "yellow");
			} else {
				passing--;
				return App.UI.DOM.makeElement("span", "FAILED", "red");
			}
		}
		return ``;
	};

	r.push(`For each slave be to examined, a fee of <span class='yellowgreen'>${cashFormat(cost)}</span> will be deducted from your account.`);
	r.push(`Updates will be posted periodically. It is your responsibility to keep up to date.`);
	r.push(`Failures will be sterilized. Please make sure your slave fits the following criteria before submitting them for testing. We shall not be held responsible for time wasted.`);
	if (!slave) {
		r.push(`Must be not; already be marked as a breeding slave, inside a fuckdoll suit, infertile and already with child.`);
	} else {
		r.push(`${slave.slaveName} is up for review:`);
	}
	App.Events.addNode(frag, r, "div");
	r = [];
	const list = App.UI.DOM.appendNewElement("ul", frag);
	if (slave) {
		test = slave.intelligence + slave.intelligenceImplant >= (eliteAngered ? 95 : 50);
	}
	App.UI.DOM.appendNewElement("li", list, `Must be ${eliteAngered ? 'highly intelligent' : 'very smart'}. `).append(result());

	if (slave) {
		test = Beauty(slave) >= (eliteAngered ? 120 : 100);
	}
	App.UI.DOM.appendNewElement("li", list, `Must be ${eliteAngered ? 'unbelievably' : ''} beautiful. `).append(result());

	if (slave) {
		test = slave.face >= (eliteAngered ? 95 : 40);
	}
	App.UI.DOM.appendNewElement("li", list, `Their face must be ${eliteAngered ? 'breathtaking' : 'gorgeous'}. `).append(result());

	if (slave) {
		test = slave.chem <= 20;
	}
	App.UI.DOM.appendNewElement("li", list, `Their health must not be overly impacted by drug use. `).append(result());

	if (slave) {
		test = slave.addict === 0;
	}
	App.UI.DOM.appendNewElement("li", list, `They must not be addicted to drugs. `).append(result());

	if (V.arcologies[0].FSMaturityPreferentialist > 20 || V.arcologies[0].FSYouthPreferentialist > 20) {
		const targetAge = 24;
		if (slave) {
			if (V.arcologies[0].FSMaturityPreferentialist > 20) {
				test = slave.physicalAge > targetAge;
			} else {
				test = slave.physicalAge < targetAge;
			}
		}
		App.UI.DOM.appendNewElement("li", list, `Must be ${preferYounger ? 'younger' : 'older'} than ${targetAge}. `).append(result());
	}

	if (V.arcologies[0].FSIntellectualDependency > 20) {
		if (slave) {
			test = slave.energy >= 96;
		}
		App.UI.DOM.appendNewElement("li", list, `Must be sexually receptive at all times. `).append(result());
	} else if (V.arcologies[0].FSSlaveProfessionalism > 20) {
		if (slave) {
			test = slave.skill.vaginal + slave.skill.anal + slave.skill.oral + slave.skill.entertainment + slave.skill.whoring >= (eliteAngered ? 500 : 400);
		}
		App.UI.DOM.appendNewElement("li", list, `Must be capable of mastering skills. `).append(result());
		if (slave) {
			test = slave.accent <= 1;
		}
		App.UI.DOM.appendNewElement("li", list, `Must be capable of eloquent and accurate speech. `).append(result());
	}
	if (V.arcologies[0].FSPetiteAdmiration > 20 || V.arcologies[0].FSStatuesqueGlorification > 20) {
		const targetHeight = V.arcologies[0].FSPetiteAdmiration > 20 ? 150 : 186;
		if (V.arcologies[0].FSPetiteAdmiration > 20) {
			if (slave) {
				test = (slave.height - (slave.heightImplant * 10)) < targetHeight;
			}
			App.UI.DOM.appendNewElement("li", list, `Must naturally be very short. (${targetHeight} cm) `).append(result());
			if (slave) {
				test = (slave.height - (slave.heightImplant * 10)) < Height.mean(slave) - 15;
			}
			App.UI.DOM.appendNewElement("li", list, `Must naturally be very short for their age. `).append(result());
		} else if (V.arcologies[0].FSStatuesqueGlorification > 20) {
			if (slave) {
				test = (slave.height - (slave.heightImplant * 10)) > targetHeight;
			}
			App.UI.DOM.appendNewElement("li", list, `Must naturally be very tall. (${targetHeight} cm) `).append(result());
		}
	}

	if (V.arcologies[0].FSSupremacist > 20 || V.arcologies[0].FSSubjugationist > 20) {
		const targetRace = V.arcologies[0].FSSupremacist > 20 ? V.arcologies[0].FSSupremacistRace : V.arcologies[0].FSSubjugationistRace;
		if (V.arcologies[0].FSSupremacist > 20) {
			if (slave) {
				test = slave.race === targetRace;
			}
			App.UI.DOM.appendNewElement("li", list, `Must be ${targetRace}. `).append(result());
		} else {
			if (slave) {
				test = slave.race !== targetRace;
			}
			App.UI.DOM.appendNewElement("li", list, `Must not be ${targetRace}. `).append(result());
		}
	}

	if (V.arcologies[0].FSGenderRadicalist > 20) {
		if (slave) {
			test = slave.dick >= 1 && slave.balls >= 1;
		}
		App.UI.DOM.appendNewElement("li", list, `Must have a functional penis. `).append(result());
	} else if (V.arcologies[0].FSGenderFundamentalist > 20) {
		if (slave) {
			test = slave.dick === 0 && slave.balls === 0;
		}
		App.UI.DOM.appendNewElement("li", list, `Must be physically female. `).append(result());
	}
	if (V.arcologies[0].FSPaternalist > 20) {
		if (slave) {
			test = slave.intelligenceImplant >= (SlaveProfessionalismEstablished ? 30 : 15);
		}
		App.UI.DOM.appendNewElement("li", list, `Must be ${SlaveProfessionalismEstablished ? 'well' : ''} educated. `).append(result());
		if (slave) {
			test = slave.health.condition >= 60;
		}
		App.UI.DOM.appendNewElement("li", list, `Must be in good health. `).append(result());
	// } else if (V.arcologies[0].FSDegradationist > 20) {
	}

	if (SlaveProfessionalismEstablished) {
		if (slave) {
			test = slave.intelligenceImplant >= 15;
		}
		App.UI.DOM.appendNewElement("li", list, `Must be well educated. `).append(result());
	}

	if (V.arcologies[0].FSBodyPurist > 20) {
		if (slave) {
			test = slave.chem <= (eliteAngered ? 0 : 15);
		}
		App.UI.DOM.appendNewElement("li", list, `Must have low carcinogen levels. `).append(result());
		if (slave) {
			test = slave.boobsImplant + slave.buttImplant + slave.lipsImplant + slave.hipsImplant + slave.shouldersImplant === 0 && slave.faceImplant <= 5 && slave.bellyImplant === -1;
		}
		App.UI.DOM.appendNewElement("li", list, `Must be implant free. `).append(result());
	// } else if (V.arcologies[0].FSTransformationFetishist > 20) {
	//	idealSlave.chem = 20;
	}
	if (V.arcologies[0].FSSlimnessEnthusiast > 20) {
		if (slave) {
			test = slave.weight <= (partyAnimal ? 30 : 0);
		}
		if (partyAnimal) {
			App.UI.DOM.appendNewElement("li", list, `May be no larger than "plush". `).append(result());
		} else {
			App.UI.DOM.appendNewElement("li", list, `Must be thin. `).append(result());
		}
		if (slave) {
			test = slave.butt <= 2;
		}
		App.UI.DOM.appendNewElement("li", list, `Must have a trim rear. `).append(result());
		if (slave) {
			test = slave.boobs <= 400;
		}
		App.UI.DOM.appendNewElement("li", list, `Must have a sleek chest. `).append(result());
	} else if (V.arcologies[0].FSAssetExpansionist > 20) {
		if (slave) {
			test = (slave.butt - slave.buttImplant) >= 6;
		}
		App.UI.DOM.appendNewElement("li", list, `Must have a naturally gigantic rear. `).append(result());
		if (slave) {
			test = (slave.boobs - slave.boobsImplant) >= 1000;
		}
		App.UI.DOM.appendNewElement("li", list, `Must be naturally busty. `).append(result());
	}
	if (V.arcologies[0].FSPastoralist > 20) {
		if (slave) {
			test = slave.lactation === 1;
		}
		App.UI.DOM.appendNewElement("li", list, `Must be lactating naturally. `).append(result());
	}
	if (V.arcologies[0].FSPhysicalIdealist > 20) {
		if (V.arcologies[0].FSPhysicalIdealistLaw === 1) {
			const musclesMin = 20;
			const musclesMax = 50;
			if (slave) {
				test = slave.weight <= 30;
			}
			App.UI.DOM.appendNewElement("li", list, `Must not be overweight. `).append(result());
			if (slave) {
				test = slave.muscles.isBetween(musclesMin, musclesMax);
				fixable = (slave.muscles <= musclesMin && slave.muscles > musclesMax - musclesMin) || (slave.muscles >= musclesMax && slave.muscles < musclesMin + 30);
				if (fixable && passing === 0) {
					passing = 2;
				}
			}
			App.UI.DOM.appendNewElement("li", list, `Must be fit, but not too muscular. `).append(result());
		} else {
			if (slave) {
				test = slave.muscles > 95;
			}
			App.UI.DOM.appendNewElement("li", list, `Must be extremely muscular. `).append(result());
		}
	} else if (V.arcologies[0].FSHedonisticDecadence > 20) {
		const targetWeight = V.arcologies[0].FSSlimnessEnthusiast > 20 ? 10 : 95;
		if (slave) {
			test = slave.weight > targetWeight;
		}
		if (V.arcologies[0].FSSlimnessEnthusiast > 20) {
			App.UI.DOM.appendNewElement("li", list, `Must be more than "trim". `).append(result());
		} else {
			App.UI.DOM.appendNewElement("li", list, `Must be big, soft and fat. `).append(result());
		}
	}

	if (slave) {
		if (passing === 2) {
			r.push(`The aforementioned slave has been deemed <span class="yellow">currently unsuitable</span> for breeding, but may be resubmitted after corrections are applied. We understand the subjective nature of "fit" and do not wish to preclude the use a viable breeder over such a trivial fix. A contraceptive routine has been applied to protect against "accidents" in the interim.`);
			slave.preg = -1;
		} else if (passing !== 0) {
			r.push(`The aforementioned slave has been deemed <span class="red">unsuitable</span> for breeding.`);
			slave.preg = -3;
		} else {
			r.push(`The aforementioned slave has been deemed <span class="green">worthy</span> of being used for breeding and has been marked as such. Please note the increased restrictions on breeding slaves.`);
			r.push(`They are not permitted for public use or anything that may harm their growing child. The child within them is considered a member of the Elite class and as such, any harm that comes to them will result in severe penalties to the breeder's owner. Development of the child will be closely monitored; should the fetus be identified as not of the owner's blood (or any other member of the Elite class), said owner shall face severe fines.`);
			slave.breedingMark = 1;
			slave.pregControl = "none";
			removeJob(slave, slave.assignment);
		}
		cashX(-cost, "capEx");
	}
	App.Events.addNode(frag, r, "div");
	return frag;
};
