/* ### Non Random Events ### */

new App.DomPassage("Nonrandom Event",
	() => {
		return nonRandomEvent();
	}
);

new App.DomPassage("attackReport",
	() => {
		return App.Events.attackReport();
	}
);

/* ### Random Events ### */

new App.DomPassage("JS Random Event",
	() => {
		V.nextButton = "Continue";

		const d = document.createElement("div");
		V.event.execute(d);
		return d;
	}
);

/* ### Scheduled Events ### */

new App.DomPassage("Scheduled Event",
	() => {
		V.nextButton = "Continue";
		V.nextLink = "Scheduled Event"; // return to self; playNonrandomEvent will forward automatically when necessary

		return App.Events.playNonrandomEvent();
	}
);

/* ### Player Events ### */

new App.DomPassage("P rivalry hostage",
	() => {
		V.nextButton = "Continue";
		V.nextLink = "Nonrandom Event";
		return App.Events.pRivalryHostage();
	}
);

new App.DomPassage("P rivalry actions",
	() => {
		V.nextButton = "Continue";
		V.nextLink = "Random Nonindividual Event";
		return App.Events.pRivalryActions();
	}
);

new App.DomPassage("P rivalry victory",
	() => {
		V.nextButton = "Continue";
		V.nextLink = "Random Nonindividual Event";
		return App.Events.pRivalryVictory();
	}
);

new App.DomPassage("P hostage acquisition",
	() => {
		V.nextButton = "Continue";
		V.nextLink = "Scheduled Event";
		V.returnTo = "Scheduled Event";
		return App.Events.pHostageAcquisition();
	}
);
